<?php
namespace FiloBlu\Flow\Model\From;

class Price extends AbstractFrom {
    
    /**
    * @var Monolog\Logger
    */
    protected $_logger;

    /**
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource $resource
     * @param \Magento\Framework\Data\Collection\Db $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Price $helper_price,
        \FiloBlu\Flow\Helper\Data $helper_flow,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Catalog\Model\ProductFactory $productFactory,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    )
    {
        $this->_helper_price = $helper_price;
        $this->_helper_flow = $helper_flow;
        $this->_storeManager = $storeManager;
        $this->_productFactory = $productFactory;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * @return void
     */
    public function _construct()
    {
        $this->_init('FiloBlu\Flow\Model\ResourceModel\From\Price');
    }


    public function process() {

        $productSku = $this->getSku();
        $paese = $this->getPaese();
        $prezzo = $this->getPrezzo();
        $valuta = $this->getValuta();

        $allStore = $this->_helper_flow->getStoreInWebsiteId();
        
        if(is_null($paese)){
            $paese = 'admin';
        }
        $storeId = $allStore[$paese]['store_id'];

        $productId = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->getIdBySku($productSku);

        if($productId){
            $product = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->load($productId);
            $product->setStoreId($storeId);
            //$product->setCurrencyCode($valuta);
            $product->setPrice($prezzo);
            $product->save();
        }

        return $this;

    }


}